/* This file is part of Om.  Copyright (C) 2006 Dave Robillard.
 * 
 * Om is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * Om is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "OmPort.h"
#include <cassert>
#include <iostream>
#include "PortModel.h"
#include "OmModule.h"
#include "ControlModel.h"
#include "Configuration.h"
#include "App.h"
using std::cerr; using std::endl;

using namespace LibOmClient;

namespace OmGtk {

OmPort::OmPort(OmModule* module, PortModel* pm)
: Port(module, pm->name(), pm->is_input(), App::instance().configuration()->get_port_color(pm)),
  m_port_model(pm)
{
	assert(module != NULL);
	assert(m_port_model != NULL);
}

#if 0
void
OmPort::set_name(const string& n)
{
	cerr << "********** OmPort::set_name broken **********************" << endl;
	
	/* FIXME: move to PortController
	string new_path = OmPath::parent(m_port_model->path()) +"/"+ n;

	for (list<ControlPanel*>::iterator i = m_control_panels.begin(); i != m_control_panels.end(); ++i)
		(*i)->rename_port(m_port_model->path(), new_path);
	
	Port::set_name(n);
	m_port_model->path(new_path);
	*/
}
#endif

} // namespace OmGtk
